module ExtendedFunctions exposing (..)


map10 :
    (a -> b -> c -> d -> e -> f -> g -> h -> i -> j -> result)
    -> Maybe a
    -> Maybe b
    -> Maybe c
    -> Maybe d
    -> Maybe e
    -> Maybe f
    -> Maybe g
    -> Maybe h
    -> Maybe i
    -> Maybe j
    -> Maybe result
map10 func maybe1 maybe2 maybe3 maybe4 maybe5 maybe6 maybe7 maybe8 maybe9 maybe10 =
    maybe1
        |> Maybe.andThen
            (\value1 ->
                maybe2
                    |> Maybe.andThen
                        (\value2 ->
                            maybe3
                                |> Maybe.andThen
                                    (\value3 ->
                                        maybe4
                                            |> Maybe.andThen
                                                (\value4 ->
                                                    maybe5
                                                        |> Maybe.andThen
                                                            (\value5 ->
                                                                maybe6
                                                                    |> Maybe.andThen
                                                                        (\value6 ->
                                                                            maybe7
                                                                                |> Maybe.andThen
                                                                                    (\value7 ->
                                                                                        maybe8
                                                                                            |> Maybe.andThen
                                                                                                (\value8 ->
                                                                                                    maybe9
                                                                                                        |> Maybe.andThen
                                                                                                            (\value9 ->
                                                                                                                maybe10
                                                                                                                    |> Maybe.map
                                                                                                                        (\value10 ->
                                                                                                                            func value1 value2 value3 value4 value5 value6 value7 value8 value9 value10
                                                                                                                        )
                                                                                                            )
                                                                                                )
                                                                                    )
                                                                        )
                                                            )
                                                )
                                    )
                        )
            )


listmap10 :
    (a -> b -> c -> d -> e -> f -> g -> h -> i -> j -> k)
    -> List a
    -> List b
    -> List c
    -> List d
    -> List e
    -> List f
    -> List g
    -> List h
    -> List i
    -> List j
    -> List k
listmap10 f la lb lc ld le lf lg lh li lj =
    let
        go xs ys zs ws vs as1 bs cs ds es acc =
            case ( xs, ys, zs ) of
                ( x :: xr, y :: yr, z :: zr ) ->
                    case ( ws, vs, as1 ) of
                        ( w1 :: wr, v :: vr, a :: ar ) ->
                            case ( bs, cs, ds ) of
                                ( b :: br, c :: cr, d :: dr ) ->
                                    case es of
                                        e :: er ->
                                            go xr yr zr wr vr ar br cr dr er (f x y z w1 v a b c d e :: acc)

                                        [] ->
                                            List.reverse acc

                                _ ->
                                    List.reverse acc

                        _ ->
                            List.reverse acc

                _ ->
                    List.reverse acc
    in
    go la lb lc ld le lf lg lh li lj []
